 include "..\ti83plus.inc"
 define program

_NewLine equ 452Eh   	; NewLine not in ti83plus.inc
 ifdef program 
 org usermem-2
 db 0BBh,06Dh
 xor a
 jr nc,start
 db "Sort programs",0
 else
 db 080h, 00Fh
 db 000h, 000h, 000h, 000h
 db 080h, 012h
 db 001h, 004h
 db 080h, 021h
 db 001h
 db 080h, 031h
 db 001h
 db 080h, 048h
 db "SORT", 000h, 000h, 000h, 000h
 db 080h, 061h
 db 010h
 db 080h, 081h
 db 001h
 db 080h, 090h
 db 003h, 026h, 009h, 004h
 db 00Bh, 061h, 034h, 067h
 db 002h, 00Dh, 040h, 0A1h, 06Bh, 099h, 0F6h, 059h, 0BCh, 067h
 db 0F5h, 085h, 09Ch, 009h, 06Ch, 00Fh, 0B4h, 003h, 09Bh, 0C9h
 db 003h, 032h, 02Ch, 0E0h, 003h, 020h, 0E3h, 02Ch, 0F4h, 02Dh
 db 073h, 0B4h, 027h, 0C4h, 0A0h, 072h, 054h, 0B9h, 0EAh, 07Ch
 db 03Bh, 0AAh, 016h, 0F6h, 077h, 083h, 07Ah, 0EEh, 01Ah, 0D4h
 db 042h, 04Ch, 06Bh, 08Bh, 013h, 01Fh, 0BBh, 093h, 08Bh, 0FCh
 db 019h, 01Ch, 03Ch, 0ECh, 04Dh, 0E5h, 075h
 db 080h, 07Fh
 db 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h
 db 000h
 endif

firstprog equ 0 ;flag in asm_Flag1
firstprogpointer 			equ appbackupscreen
endofsortedpartpointer 	equ appbackupscreen+2
vatentrysize				equ appbackupscreen+3
vatentrynewloc				equ appbackupscreen+6
vatentrytempstart			equ appbackupscreen+8
vatentrytempend			equ appbackupscreen+8+15 

start:
	in a,(2)
	and 80h
	rlca
	out (20h),a ;full speed on se
	call sort
	ifdef program
	ret
	else
	B_JUMP JForceCmdNoChar
	endif

sort:	
	res firstprog,(IY+asm_Flag1)
	ld hl,(progptr)
sort_next:
	call findnextitem
	ret nc
	bit firstprog,(IY+asm_Flag1)
	jp z,firstprogfound
	push hl
	call skipname
	pop de 
	push hl ;to continue from later on
	ld hl,(firstprogpointer)
	jr searchnext_start ;could speed up sorted list by first checking if it's the last item (not neccessary)
searchnext:
	call skipname
	ld bc,(endofsortedpartpointer)
	or a ;reset carry flag
	push hl
	sbc hl,bc
	pop hl
	jr z,locationfound
	ld bc,-6
	add hl,bc
searchnext_start:
	push hl
	push de
	call comparestrings
	pop de
	pop hl
	jr nc,searchnext
searchnext_end:
	ld bc,6
	add hl,bc ;goto start of entry
locationfound:
	ex de,hl
	ld a,(hl)
	add 7
	ld bc,6 ;rewind six bytes
	add hl,bc

	;a=nr of bytes to move
	;hl=pointer to the bytes to move
	;de=pointer to move to
	ld b,0
	ld c,a
	ld (vatentrysize),bc
	ld (vatentrynewloc),de
	push de
	push hl
	or a
	sbc hl,de
	pop hl
	pop de
	jr z,nomoveneeded
	push hl
	ld de,vatentrytempend
	lddr ;copy entry to move to vatentrytempend

	ld hl,(vatentrynewloc)
	pop bc
	push bc
	or a
	sbc hl,bc
	ld b,h
	ld c,l ;bc calculated right

	pop hl
	inc hl
	push hl
	ld de,(vatentrysize)
	or a
	sbc hl,de 
	ex de,hl
	pop hl
	ldir

	ld hl,vatentrytempend
	ld bc,(vatentrysize)
	ld de,(vatentrynewloc)
	lddr
	ld hl,(endofsortedpartpointer)
	ld bc,(vatentrysize)
	or a
	sbc hl,bc
	ld (endofsortedpartpointer),hl
	pop hl ;pointer to continue from
	jp sort_next ;to skip name and rest of entry

nomoveneeded:
	pop hl
	ld (endofsortedpartpointer),hl
	jp sort_next
	

firstprogfound:
	set firstprog,(IY+asm_Flag1) ;to make it only execute once
;	push hl
;	ld bc,6
;	add hl,bc ;rewind six bytes
	ld (firstprogpointer),hl
;	pop hl
	call skipname
	ld (endofsortedpartpointer),hl
	jp sort_next

;skiptonext0:
;	ld de,0
;	jr skiptonext
skiptonext6:
	ld bc,-6
	add hl,bc
	call skipname
	jp findnextitem

skipname:
	ld c,(hl) ;nr of bytes in name
	inc c ;to get pointer to data type byte of next entry
	ld b,0
	or a ;reset carry flag
	sbc hl,bc
	ret
	

comparestrings: ;hl and de pointers to strings output=carry if de is first
	ld b,(hl)
	ld a,(de)
	ld c,0
	cp b ;check if same length
	jr z,comparestrings_continue
	jr nc,comparestrings_continue ;b=smaller than a
	inc c ;to remember that b was larger
	ld b,a ;b was larger than a
comparestrings_continue:
	dec hl
	dec de
	ld a,(de)
	cp (hl)
	ret nz 
	djnz comparestrings_continue
comparestrings_checklength:
	dec c
	jr nz,comparestrings_checklength_nochange
	ccf
comparestrings_checklength_nochange:
	ret

findnextitem: ;c=found nc=notfound
	ex de,hl
	ld hl,(ptemp)
	or a ;reset carry flag
	sbc hl,de
	ret z
	ex de,hl ;load progptr into hl
	ld a,(hl)
	and 1Fh ;mask out state bytes
	push hl
	ld hl,programtypes
	ld bc,3
	cpir
	pop hl
	jp nz,skiptonext6 ;skip to next entry
	dec hl
	;add check for folders here if needed
	dec hl
	dec hl ;to pointer
	ld e,(hl)
	dec hl
	ld d,(hl) ;pointer now in de
	dec hl
	ld a,(hl) ;page now in a
	dec hl
	;add check: do I need to sort this program (not neccessary)
	scf
	ret	

programtypes:
	db progobj,protprogobj,tempprogobj
